<template>
  <PageWrapper dense>
    <Row>
      <!-- 左边部门选择 -->
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 4 }" class="h-[calc(100vh-80px)]">
        <DeptTree
          v-model:selectDeptId="selectDeptId"
          v-model:searchValue="searchValue"
          @select="reload"
        />
      </Col>
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 20 }">
        <BasicTable @register="registerTable">
          <template #toolbar>
            <!-- <a-button @click="handleImport" v-auth="'system:user:import'">导入</a-button> -->
            <a-button
              type="primary"
              @click="
                downloadExcel(elevatorRunDataExport, `电梯运行数据数据`, {
                  ...getForm().getFieldsValue(),
                })
              "
              v-auth="'elevator:faultStatistics:export'"
              >导出</a-button
            >
            <!-- <a-button
              type="primary"
              danger
              @click="multipleRemove(infoRemove)"
              :disabled="!selected"
              v-auth="'elevator:info:remove'"
              >删除</a-button
            >
            <a-button type="primary" @click="handleAdd" v-auth="'elevator:info:add'"
              >新增</a-button
            > -->
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:faultStatistics:query',
                    onClick: handCheck.bind(null, record),
                  },
                ]"
              />
            </template>
          </template>
        </BasicTable>
      </Col>
    </Row>
    <InfoModal @register="registerModal" @reload="reload" />
    <UserImportModal @register="registerImportModal" @reload="reload" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { Row, Col, Space, Avatar } from "ant-design-vue";
import { elevatorRunDataExport } from "@/api/basicInfo/evaDeviceRelation";
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import { infoRemove, evaRunDataList, evaBadDataEList } from "@/api/basicInfo/elevator";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import InfoModal from "./InfoModal.vue";
import { formSchemas, columns } from "./info.data";
import { IconEnum } from "@/enums/appEnum";
import { ref, toValue } from "vue";
import DeptTree from "./DeptTree.vue";
import UserImportModal from "./UserImportModal.vue";
defineOptions({ name: "Info" });
// 左边部门用
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "电梯故障数据统计列表",
  api: evaBadDataEList,
  showIndexColumn: false,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      // await reload();
    },
  },
  columns: columns,
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  actionColumn: {
    width: 100,
    title: "操作",
    key: "action",
    fixed: "right",
  },
});

const [registerModal, { openModal }] = useModal();
const [registerImportModal, { openModal: openImportModal }] = useModal();
function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}

function handleAdd() {
  openModal(true, { update: 2 });
}
function handleImport() {
  openImportModal(true);
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
async function handleDelete(record: Recordable) {
  await infoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
